
; ========================================================
;			
;    -- VM_Testing.asm --
;			Jay Sullivan
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------
dwReservedPages equ 22
dwPageSize equ 4096

	include VM_Testing.inc
	
	.DATA
	ClassName		db "MainWinClass",0
	szAppName		db "VM",0
	szCEdit			db "EDIT",0
	
	
	.DATA?
	hInstance		HINSTANCE ?
	CommandLine		LPSTR ?
	hHeap			HANDLE ?
	myEdit1			HWND ?
	hwnd			HWND ?
	lpVirtualBase   dword ?
	lpVirtualCurrent   dword ?
	


	
	include VM_Grid.asm
		
	
		
		
		
;------------------------------------------------
;                .CODE
;------------------------------------------------
.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		;invoke SetUnhandledExceptionFilter,Offset _except_handler 
		invoke GetProcessHeap
		mov hHeap, eax	
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG


	;------------------------------------------------
	;	Set up Error Handler
	;------------------------------------------------
		
		push dword ptr offset _except_handler
		push dword ptr fs:[0]
		mov dword ptr fs:[0], esp
		
	;------------------------------------------------
	;	Main Window Class
	;------------------------------------------------
		
		mov wc.cbSize, Sizeof WNDCLASSEX
		mov wc.style, CS_HREDRAW or CS_VREDRAW
		mov wc.lpfnWndProc, Offset WndProc
		mov wc.cbClsExtra,NULL
		mov wc.cbWndExtra,NULL
		mov eax,hInst
		mov wc.hInstance,eax
		mov wc.hbrBackground, COLOR_BACKGROUND
		mov wc.lpszMenuName, NULL
		mov wc.lpszClassName, Offset ClassName
		invoke LoadIcon, NULL,IDI_EXCLAMATION
		mov wc.hIcon,eax
		mov wc.hIconSm,0
		invoke LoadCursor, NULL, IDC_ARROW
		mov wc.hCursor,eax
		invoke RegisterClassEx, ADDR wc
		
	;------------------------------------------------
	;	Windows
	;------------------------------------------------
		
		;-----------------------------
		;	Main Window
		;-----------------------------
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,CW_USEDEFAULT,640,450,\
				NULL,NULL,hInst,NULL
			mov hwnd,eax
			

			
		;-----------------------------
		;	Map Window
		;-----------------------------
			invoke GridRegister
			invoke GridItemRegister
			
			invoke CreateWindowEx, WS_EX_STATICEDGE, ADDR grid_ClassName, ADDR szAppName,\
				 WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,\
				480,0,115,400,\
				hwnd,NULL,hInst,NULL
			mov grid_Wnd,eax
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------


WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	;-----------------------------
	 .if eax==WM_DESTROY ; uMsg
	;-----------------------------
		
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .elseif eax==WM_CREATE ; uMsg
	;-----------------------------
		;----------------------------------------------
		;       Reserve 256 pages of memory
		;----------------------------------------------
			
				invoke VirtualAlloc,0,dwPageSize*dwReservedPages, MEM_RESERVE, PAGE_READWRITE or PAGE_GUARD 
				mov lpVirtualBase, eax
				mov lpVirtualCurrent, eax
				.if eax==0
					invoke MessageBox,hwnd,$String("VirtualAlloc returned zero."),$String("*VirtualAlloc failed.*"),MB_OK
				.endif

				
				invoke VirtualAlloc,lpVirtualCurrent,dwPageSize, MEM_COMMIT, PAGE_READWRITE or PAGE_GUARD 
				.if eax==0
					invoke MessageBox,hwnd,$String("VirtualAlloc returned zero."),$String("*VirtualAlloc failed.*"),MB_OK
				.endif
				
		;----------------------------------------------
		;       Set up edit box
		;----------------------------------------------
		
			btnSTYLE equ WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT
			btnExSTYLE equ WS_EX_STATICEDGE
			
			invoke CreateWindowEx, WS_EX_STATICEDGE , Offset szCEdit, 0, btnSTYLE or ES_MULTILINE or WS_VSCROLL or DS_LOCALEDIT,0,0,475,400,hWnd,0,hInstance,0
			mov myEdit1,eax
			invoke SendMessage, myEdit1, EM_SETHANDLE, lpVirtualBase, 0
			invoke SendMessage, myEdit1, EM_SETLIMITTEXT, lpVirtualBase, dwPageSize*dwReservedPages
			
	;-----------------------------
	 .elseif eax==WM_ERASEBKGND; uMsg
	;-----------------------------
	
	;-----------------------------
	 .elseif eax==WM_GETMINMAXINFO  ; uMsg
	;-----------------------------
		mov eax, lParam
		mov  dword ptr [eax+24] , 250
		
		
		
	;-----------------------------
	 .elseif eax==WM_COMMAND ; uMsg
	;-----------------------------
	
		movzx eax, word ptr wParam
		.if eax==EN_ERRSPACE
			invoke MessageBox,hwnd,$String("An ERRSPACE message was sent."),$String("ERRSPACE"),MB_OK
		.endif
		
	;-----------------------------
	 .elseif eax==WM_SIZE ; uMsg
	;-----------------------------
	
		movzx eax, word ptr lParam
		movzx ecx, word ptr lParam+2
		sub eax, 115
		push eax
		push ecx
		invoke MoveWindow,myEdit1,0,0,eax,ecx,TRUE
		pop ecx
		pop eax
		invoke MoveWindow,grid_Wnd,eax,0,115,ecx,FALSE
		
	;-----------------------------
	 .elseif eax==WM_DESTROY ; uMsg
	;-----------------------------
	
		mov ecx, lpVirtualCurrent
		sub ecx, lpVirtualBase
		
		invoke VirtualFree,lpVirtualBase,ecx,MEM_DECOMMIT
		.if eax==0
			invoke MessageBox,hwnd,$String("VirtualFree returned zero."),$String("*Could not DECOMMIT*"),MB_OK
		.endif
		
		invoke VirtualFree,lpVirtualBase,dwPageSize*dwReservedPages, MEM_RELEASE
		.if eax==0
			invoke MessageBox,hwnd,$String("VirtualFree returned zero."),$String("*Could not RELEASE*"),MB_OK
		.endif
		
	    invoke PostQuitMessage,NULL
	    mov	eax,0
	    ret
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP


 ;struct _EXCEPTION_RECORD *ExceptionRecord,
 ;void * EstablisherFrame,
 ;struct _CONTEXT *ContextRecord,
 ;void * DispatcherContext


itoaStack PROC uses ebx i:DWORD, pStr:DWORD
    mov ebx,10
	mov eax, i
	mov ecx, pStr
	
	  sub esp, 1			; .. push byte
	  mov byte ptr [esp], 0 ; .. push byte
repzz:
	xor edx,edx
	div ebx		; divide ebx by 10, put remainder in edx
	add edx, 30h
	  sub esp, 1			 ; .. push byte
	  mov byte ptr [esp], dl ; .. push byte
	test eax, eax
	jnz repzz
	
	xor eax, eax
unrepzz:
	 mov al, byte ptr [esp] ; ... pop byte
	 mov byte ptr [ecx], al ; ... pop byte
	 add esp, 1				; ... pop byte
	add ecx, 1
	test eax, eax
	jnz unrepzz
	
	
	Ret
itoaStack ENDP



.data
ErrorText db "Error #"
OutError dd 64 dup(0)
.code


_except_handler  PROC C ExceptionRecord:DWORD, EstablisherFrame:DWORD, ContextRecord:DWORD, DispatcherContext:DWORD
LOCAL errcode:DWORD,
      errloc:DWORD
      
    
	mov eax, ExceptionRecord
	
	;-----------------------------------
	;      Exit if we're unwinding
	;-----------------------------------
		.if dword ptr [eax+4]==2
			mov eax, ExceptionContinueSearch
			ret
		.endif
	
	mov eax, dword ptr [eax]
	mov errcode, eax
	
	invoke itoaStack,errcode,Offset OutError
	
	mov eax, ExceptionRecord
    .if errcode== 080000001h  ; 2,147,483,649
		invoke MessageBox,hwnd,$String("New Page Committed"),$String("*Page Guard*"),MB_OK
		add lpVirtualCurrent, dwPageSize
		invoke VirtualAlloc,lpVirtualCurrent,dwPageSize, MEM_COMMIT, PAGE_READWRITE or PAGE_GUARD 
		.if eax==0
			invoke MessageBox,hwnd,$String("VirtualAlloc returned zero."),$String("*VirtualAlloc failed.*"),MB_OK
		.endif
		
		
		
	  	;; Get Attempted Address#
			mov eax, ExceptionRecord
			mov eax, [eax]._EXCEPTION_RECORD.ExceptionInformation+4
			mov errloc, eax
		;;
	  	;; Get Page#
		  	mov eax, errloc
		  	sub eax, lpVirtualBase
		  	shr eax, 12
		  	
		  	
		  	shl eax, 4 ;  (gSIZE SHR 4)
	  	;;
	  	;;  Update Grid
		  	mov ecx, gridItems
		  	mov [ecx+eax].GridItemVars.state, 1
	  	;;
	  	invoke InvalidateRect, [ecx+eax].GridItemVars.hWnd, 0, FALSE
	  	mov eax, ExceptionContinueExecution
	  	ret
	.else 
		invoke MessageBox,hwnd,$String("Error !!!!!!!!!!!!!!!!!!!!!!!!"),Offset ErrorText,MB_OK
	.endif
	
	mov eax, ExceptionContinueSearch
	ret
_except_handler  ENDP

End Start